// testuojam bitikzyz VM
// yra 2 klases: Nulis ir Vienas (extends Nulis).
/* Nulis turi metoda funcBTZ, kuris grazina argumenta kvadratu.
   taip pat turi metoda funcCPP, implementuota C++ (zr. zemiau).
   Vienas turi funcCPP, ale implementuota BiTikZyz.

   Nulis turi f-ja test, kuri kviecia funcCPP. taigi objektui Nulis
   turi iskviesti native funcCPP; o objektui Vienas - BiTikZyz funcCPP.

   Nulis::test() taip pat testuoja statinius kintamuosius - priskyrus
   vienam reiksme, visuose objektuose pasikeicia (tie 13 13, kur spausdina).
*/

//#include <cstring>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

using namespace std;

#ifdef MMGR
#include "../utils/mmgr.h"
#endif

#include "bitikzyz.h" // sugeneruotas ish sorsu

// Nulis native metodas
long Nulis::funcCPP(long a)
{
        printf(" o! ash native metodas!\n");
        printf("   man duoda %li\n", a);
        printf("   kvieciu funcBTZ()\n");
        a = funcBTZ(a);
        printf("   gavosi %li\n", a);
        printf(" einu lauk\n");
        return a;
}

// pagrindine
int main()
{
        // sukuriam objektus
        Nulis* n = (Nulis*)bitikzyz.create(IDNulis);
        Vienas* v = (Vienas*)bitikzyz.create(IDVienas);
        printf("vykdau...\n");
        // testuojam
        printf("test Nulis...\n");
        n->test();
        printf("test Vienas...\n");
        v->test();
        // baigiam
        printf("baigiu...\n");
        delete n;
        delete v;
        return 0;
}

